/**
 * 
 */
package be.AM4DP;

import java.util.Properties;

import be.SIRAPRISE.client.DBConnectionProperties;
import be.SIRAPRISE.util.MyProperties;

/**
 * To configure the AM4DPWebClientFunction, do one of the following :
 * <ol>
 * <li>Define InitParams for the Context that runs this AM4DPWebClientFunction.  The InitParams must be named be.AM4DP.AM4DPWebClientFunctionProperties.&lt;propertyname&gt; </li>
 * <li>In the ${user.home} directory of the user that is running the application server, create a folder with the same name as the application's context path.  In that folder, create a file named "application.properties".  In that file, define the properties using the same naming convention as in the foregoing approach.</li>
 * <li>place a properties file be/AM4DP/AM4DPWebClientFunction.properties in the classpath of the web application (e.g. the WEB-INF/classes folder of the web application).  Disadvantage of this approach : un- or redeploying is likely to remove your config data as well.</li>
 * <li>place a properties file be.AM4DP.AM4DPWebClientFunction.properties in the ${user.home} directory of the user that is running the application server.  Disadvantage of this approach : no possibility to configure on a per-context basis.</li>
 * </ol>
 * 
 * The configurable properties are the following :
 * <ul>
 * <li>HOST - the DNS name or IP address of the host where the SIRA_PRISE server is running.</li>
 * <li>PORT - the IP port number on the indicated HOST to use for connecting to the SIRA_PRISE server.</li>
 * <li>SIGNINGALGORITHMS - A comma-separated list of signing algorithm names to be used by this client in its communications with the SIRA_PRISE server.</li>
 * <li>CRYPTOALGORITHMS - A comma-separated list of cipher algorithm names to be used by this client in its communications with the SIRA_PRISE server.</li>
 * <li>SIGNERCLASSNAME - The class name of the class that will be doing the message signing, if a signing algorithm is used in the communications with the SIRA_PRISE server.</li>
 * </ul>
 * 
 * @author Erwin
 * 
 */
final class AM4DPWebClientFunctionProperties extends MyProperties {

	/**
	 * 
	 */
	private static final Properties instance = new AM4DPWebClientFunctionProperties();

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * @return the instance
	 */
	static Properties getInstance ( ) {
		return instance;
	}

	/**
	 * Creates the AM4DPWebClientFunctionProperties
	 * 
	 */
	private AM4DPWebClientFunctionProperties ( ) {
		super(DBConnectionProperties.getInstance());
	}
}
