/**
 * 
 */
package be.ASPL.presentationlayer;

import java.util.Locale;
import java.util.Properties;

/**
 * @author Erwin
 * 
 */
final class FileUploadRenderer extends Renderer {

	/**
	 * 
	 */
	private static final String DEFAULTCSSCLASS = "inputfile"; //$NON-NLS-1$

	/**
	 * 
	 */
	private static final FileUploadRenderer instance = new FileUploadRenderer();

	/**
	 * @return
	 */
	static FileUploadRenderer getInstance ( ) {
		return instance;
	}

	/**
	 * Creates the FileUploadRenderer
	 * 
	 */
	private FileUploadRenderer ( ) {

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.presentationlayer.Renderer#getEmptyHTML(be.ASPL.presentationlayer.PresentationField, java.util.Locale, java.util.Properties)
	 */
	@Override
	String getEmptyHTML (PresentationField presentationField, Locale locale, Properties presentationLocaleLabels) {
		return "<INPUT" + getHTMLCssClassSpec(presentationField, DEFAULTCSSCLASS) + " type=\"file\" name=\"" + presentationField.getName() + "\"" + (presentationField.isInputEnabled() ? "" : "disabled=\"disabled\"") + getHTMLTabIndexSpec(presentationField) + ">"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.presentationlayer.Renderer#getHTML(be.ASPL.presentationlayer.PresentationValue, be.ASPL.presentationlayer.OnLinePresentationFunction, be.ASPL.presentationlayer.PresentationField, java.util.Locale, java.util.Properties)
	 */
	@Override
	String getHTML (PresentationValue presentationFieldValue, OnLinePresentationFunction userFunction, PresentationField presentationField, Locale locale, Properties presentationLocaleLabels) {
		if (presentationFieldValue instanceof BlobValue) {
			StringBuilder fieldHtml = new StringBuilder(80).append("<INPUT" + getHTMLCssClassSpec(presentationField, DEFAULTCSSCLASS) + " type=\"file\" name=\"" + presentationField.getName() + "\""); //$NON-NLS-1$//$NON-NLS-2$ //$NON-NLS-3$
			if (!presentationField.isInputEnabled()) {
				fieldHtml.append(" disabled=\"disabled\" "); //$NON-NLS-1$
			}
			fieldHtml.append(getHTMLTabIndexSpec(presentationField)).append(">"); //$NON-NLS-1$
			return fieldHtml.toString();
		} else {
			throw new IllegalArgumentException(presentationFieldValue.getClass().getName());
		}
	}

}
