package be.ASPL.presentationlayer;

/**
 * LogicalValue is the Presentation layer attribute type for logical (boolean) values
 * 
 * @author Erwin
 */
public final class LogicalValue implements PresentationValue {

	/**
	 * The boolean value
	 */
	private boolean value;

	/**
	 * Creates the LogicalValue
	 * 
	 * @param value
	 *            The boolean value
	 */
	public LogicalValue (boolean value) {
		this.value = value;
	}

	/**
	 * Gets The logical value
	 * 
	 * @return The logical value
	 */
	public boolean getValue ( ) {
		return value;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString ( ) {
		return Boolean.toString(value);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.presentationlayer.WaarValue#toWAARString(be.ASPL.presentationlayer.UserData)
	 */
	@Override
	public String toASPLString (UserData userData) {
		return Boolean.toString(value);
	}
}
