/**
 * 
 */
package be.ASPL.presentationlayer;

import java.util.Locale;
import java.util.Properties;

/**
 * @author Erwin
 */
public final class TextAreaRenderer extends Renderer {

	/**
	 * 
	 */
	private static final String DEFAULTPRESENTATIONSIZESPEC = "5"; //$NON-NLS-1$

	/**
	 * 
	 */
	private static final String DEFAULTCSSCLASS = ""; //$NON-NLS-1$

	/**
	 * 
	 */
	public static final String TEXTAREA = "textarea"; //$NON-NLS-1$

	/**
	 * 
	 */
	private static Renderer instance = new TextAreaRenderer();

	/**
	 * @return
	 */
	static Renderer getInstance ( ) {
		return instance;
	}

	/**
	 * Creates the TextAreaRenderer
	 * 
	 */
	private TextAreaRenderer ( ) {

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.erwinsmout.ASPL.presentationlayer.Renderer#emptyHTML(be.erwinsmout.ASPL.presentationlayer.PresentationField)
	 */
	@Override
	String getEmptyHTML (PresentationField presentationField, Locale locale, Properties presentationLocaleLabels) {
		if (presentationField.isInputEnabled()) {
			return "<TEXTAREA" + getHTMLCssClassSpec(presentationField, DEFAULTCSSCLASS) + " name=\"" + presentationField.getName() + "\" rows=\"" + presentationField.getPresentationSizeSpec(DEFAULTPRESENTATIONSIZESPEC) + "\" " + getHTMLTabIndexSpec(presentationField) + "></TEXTAREA>"; //$NON-NLS-1$//$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
		} else {
			return ""; //$NON-NLS-1$
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.erwinsmout.ASPL.presentationlayer.Renderer#renderHTML(be.erwinsmout.ASPL.WaarValue, be.erwinsmout.ASPL.presentationlayer.OnLinePresentationFunction, be.erwinsmout.ASPL.presentationlayer.PresentationField)
	 */
	@Override
	String getHTML (PresentationValue presentationFieldValue, OnLinePresentationFunction userFunction, PresentationField presentationField, Locale locale, Properties presentationLocaleLabels) {
		if (presentationField.isInputEnabled()) {
			return "<TEXTAREA" + getHTMLCssClassSpec(presentationField, DEFAULTCSSCLASS) + " name=\"" + presentationField.getName() + "\" rows=\"" + presentationField.getPresentationSizeSpec(DEFAULTPRESENTATIONSIZESPEC) + "\" " + getHTMLTabIndexSpec(presentationField) + ">" + presentationFieldValue.toASPLString(userFunction.getUserData()) + "</TEXTAREA>"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
		} else {
			return ""; //$NON-NLS-1$
		}
	}
}
