/**
 * 
 */
package be.ASPL.presentationlayer;

import java.util.Locale;
import java.util.Properties;

/**
 * @author Erwin
 */
final class UploadButtonRenderer extends Renderer {

	/**
	 * No default css class needed because SELECT comboboxes don't have distinct 'types', like the INPUT tag does. Meaning default presentation style can be entered directly in the StyleSheet
	 */
	private static final String DEFAULTCSSCLASS = ""; //$NON-NLS-1$

	/**
	 * 
	 */
	private static Renderer instance = new UploadButtonRenderer();

	/**
	 * @return
	 */
	static Renderer getInstance ( ) {
		return instance;
	}

	/**
	 * Creates the ComboBoxRenderer
	 * 
	 */
	private UploadButtonRenderer ( ) {

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.erwinsmout.ASPL.presentationlayer.Renderer#emptyHTML(be.erwinsmout.ASPL.presentationlayer.PresentationField)
	 */
	@Override
	String getEmptyHTML (PresentationField presentationField, Locale locale, Properties presentationLocaleLabels) {
		if (presentationField.isInputEnabled()) {
			return "<INPUT TYPE=\"FILE\" " + getHTMLCssClassSpec(presentationField, DEFAULTCSSCLASS) + " NAME=\"" + presentationField.getName() + "\">"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		} else {
			return ""; //$NON-NLS-1$
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.erwinsmout.ASPL.presentationlayer.Renderer#renderHTML(be.erwinsmout.ASPL.WaarValue, be.erwinsmout.ASPL.presentationlayer.OnLinePresentationFunction, be.erwinsmout.ASPL.presentationlayer.PresentationField)
	 */
	@Override
	String getHTML (PresentationValue presentationFieldValue, OnLinePresentationFunction userFunction, PresentationField presentationField, Locale locale, Properties presentationLocaleLabels) {
		if (presentationField.isInputEnabled()) {
			return "<INPUT TYPE=\"FILE\" " + getHTMLCssClassSpec(presentationField, DEFAULTCSSCLASS) + " NAME=\"" + presentationField.getName() + "\">"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		} else {
			return ""; //$NON-NLS-1$
		}
	}
}
