package be.ASPL.webclient;

import java.util.HashMap;
import java.util.Iterator;

import be.ASPL.presentationlayer.*;

/**
 * The AttributeTypePoolOverview displays a list of types on the attribute pool
 * 
 * @author Erwin
 */
@InitialPresentation(initialPresentationClass = AttributeTypePoolOverviewPresentation.class)
@OnLinePresentationFunctionCharacteristics(leaveFunctionOnExit = false, descriptionLocalizationKey = "")
public class AttributeTypePoolOverview extends ASPLWebClientFunction {

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.PresentationFunction#startFunction()
	 */
	public void doInitialLogic ( ) throws ASPLException {
		doPresentationLogic();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.PresentationFunction#doPresentationLogic()
	 */
	public void doPresentationLogic ( ) throws ASPLException {
		ListValue lv = new ListValue("ATTRIBUTETYPELIST"); //$NON-NLS-1$
		HashMap<String, PresentationType<?>> atpool = Architecture.getAttributeTypePool().getPool();
		synchronized (atpool) {
			Iterator<String> i = atpool.keySet().iterator();
			while (i.hasNext()) {
				HashMap<String, PresentationValue> m = new HashMap<String, PresentationValue>();
				m.put("NAME", new StringValue(i.next())); //$NON-NLS-1$
				lv.append(m);
			}
		}
		setPresentationValue("ATTRIBUTETYPELIST", lv); //$NON-NLS-1$
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.erwinsmout.ASPL.presentationlayer.OnLinePresentationFunction#doResumeLogic()
	 */
	public void doResumeLogic ( ) throws ASPLException {
		doPresentationLogic();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.PresentationFunction#getPresentationFunctionDescription()
	 */
	public String getPresentationFunctionDescription () {
		return "Manage Attribute Pool"; //$NON-NLS-1$
	}
}
