package be.ASPL.webclient;

import be.ASPL.presentationlayer.*;

/**
 * AttributeTypePoolRemove is the Function through which an AttributeType can be removed from the Pool
 * 
 * @version 1.0
 * @author Erwin
 */
@InitialPresentation(initialPresentationClass = AttributeTypePoolRemovePresentation.class)
@OnLinePresentationFunctionCharacteristics(leaveFunctionOnExit = true, descriptionLocalizationKey = "")
public class AttributeTypePoolRemove extends ASPLWebClientFunction {

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.PresentationFunction#startFunction()
	 */
	public void doInitialLogic ( ) {

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.PresentationFunction#doPresentationLogic()
	 */
	public void doPresentationLogic ( ) {
		Architecture.getAttributeTypePool().remove(((StringValue) getPresentationValue("NAME")).getString()); //$NON-NLS-1$
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.PresentationFunction#getPresentationFunctionDescription()
	 */
	public String getPresentationFunctionDescription () {
		return "Remove an AttributeType from its Pool"; //$NON-NLS-1$
	}
}
