package be.SIRAPRISE.birdwatcher;

import java.util.LinkedList;

import be.ASPL.presentationlayer.*;
import be.SIRAPRISE.client.ConnectionClosedException;
import be.SIRAPRISE.client.DBConnection;
import be.SIRAPRISE.client.TransactionMode;
import be.SIRAPRISE.client.jsba.DmlAssignmentCommand;
import be.SIRAPRISE.client.jsba.DmlCommand;
import be.SIRAPRISE.client.jsba.DmlMultipleAssignmentCommand;
import be.SIRAPRISE.messages.ErrorMessageException;

/**
 * The function to create a new existing species
 * 
 * @author Erwin
 */
@InitialPresentation(initialPresentationClass = PossibleSpeciesPresentation.class)
@OnLinePresentationFunctionCharacteristics(leaveFunctionOnExit = true, descriptionLocalizationKey = "PossibleSpeciesCreate.Text")
public class PossibleSpeciesCreate extends BWWebClientFunction {

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.OnLinePresentationFunction#doPresentationLogic()
	 */
	public void doPresentationLogic ( ) throws ASPLException {
		LinkedList<DmlAssignmentCommand> commands = new LinkedList<DmlAssignmentCommand>();
		commands.add(new ExistingSpecies(((StringValue) getPresentationValue(ATTRIBUTENAMES.SPECIESNAME)).getString()).dbAddCommand(RELVARNAMES.POSSIBLESPECIES));

		
		try (DBConnection dbc = getDBConnection();) {
			DmlCommand.execDmlCommandAndEndTransaction(dbc.startTransaction(getUserData().getUserID(), true, "", new byte[] {}, TransactionMode.UPDATE), new DmlMultipleAssignmentCommand(commands)); //$NON-NLS-1$
		} catch (ConnectionClosedException e) {
			log(e);
			throw new ASPLApplicationException(e);
		} catch (ErrorMessageException e) {
			log(e);
			throw new ASPLApplicationException(e);
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.OnLinePresentationFunction#doResumeLogic()
	 */
	public void doResumeLogic ( ) throws ASPLException {
		doPresentationLogic();
	}
}