/**
 * 
 */
package be.SIRAPRISE.tests.officialtestset;

import java.io.PrintStream;
import java.util.logging.Level;
import java.util.logging.LogRecord;

import be.SIRAPRISE.typeimplementations.Relation;
import be.SIRAPRISE.util.MyMessageFormat;

/**
 * DifferingREsultDetails
 * 
 * @author erwin
 */
final class DifferingResultDetails extends TestResultDetails {

	/**
	 * 
	 */
	private Relation unexpectedTuplesObtained;

	/**
	 * 
	 */
	private Relation expectedTuplesMissing;

	/**
	 * 
	 */
	private Relation obtainedRelationValue;

	/**
	 * 
	 */
	private String expectedRelationValue;

	/**
	 * Creates the DifferingREsultDetails
	 * 
	 * @param expectedRelationValue
	 * @param obtainedRelationValue
	 * @param expectedTuplesMissing
	 * @param unexpectedTuplesObtained
	 */
	DifferingResultDetails (String expectedRelationValue, Relation obtainedRelationValue, Relation unexpectedTuplesObtained, Relation expectedTuplesMissing) {
		this.expectedRelationValue = expectedRelationValue;
		this.obtainedRelationValue = obtainedRelationValue;
		this.expectedTuplesMissing = expectedTuplesMissing;
		this.unexpectedTuplesObtained = unexpectedTuplesObtained;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.SIRAPRISE.tests.officialtestset.TestResultDetails#getLogRecord()
	 */
	@Override
	LogRecord getLogRecord ( ) {
		return new LogRecord(Level.WARNING, message());
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.SIRAPRISE.tests.officialtestset.TestResultDetails#log(java.io.PrintStream)
	 */
	@Override
	void log (PrintStream out) {
		out.println(message());
	}

	/**
	 * @return
	 */
	private String message ( ) {
		return MyMessageFormat.format("Expected relation value {0}\r\nObtained relation value {1}\r\nObtained unexpected tuples {2}\r\nMissing expected tuples {3}.", new String[] { expectedRelationValue, obtainedRelationValue.printValueWithoutTypeNames(), unexpectedTuplesObtained.printValueEscapedWithoutTypeNames(), expectedTuplesMissing.printValueEscapedWithoutTypeNames() }); //$NON-NLS-1$
	}

}
