/**
 * 
 */
package be.SIRAPRISE.tests.officialtestset;

import java.io.PrintStream;
import java.util.Collection;
import java.util.logging.Level;
import java.util.logging.LogRecord;

import be.SIRAPRISE.util.MyMessageFormat;

/**
 * ExceptionNumberMismatch
 * 
 * @author erwin
 * 
 * 
 */
final class ExceptionNumberMismatch extends TestResultDetails {

	/**
	 * 
	 */
	private long errorNumber;

	/**
	 * 
	 */
	private Collection<Long> expectedErrorNumbers;

	/**
	 * 
	 */
	private String expectedMessage;

	/**
	 * 
	 */
	private String gottenMessage;

	/**
	 * Creates the ExceptionNumberMismatch
	 * 
	 * @param expectedErrorNumbers
	 * @param errorNumber
	 * @param expectedMessage 
	 * @param gottenMessage 
	 */
	ExceptionNumberMismatch (Collection<Long> expectedErrorNumbers, long errorNumber, String expectedMessage, String gottenMessage) {
		this.expectedErrorNumbers = expectedErrorNumbers;
		this.errorNumber = errorNumber;
		this.expectedMessage=expectedMessage;
		this.gottenMessage=gottenMessage;
	}

	/**
	 * @return
	 */
	private String message ( ) {
		return MyMessageFormat.format("Exception number mismatch : expected {0} gotten {1}", new String[] { expectedErrorNumbers.toString(), Long.toString(errorNumber) }) + System.getProperty("line.separator") + " expected msg : " + expectedMessage + System.getProperty("line.separator") + " obtained msg : " + gottenMessage; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.SIRAPRISE.tests.officialtestset.TestResultDetails#getLogRecord()
	 */
	@Override
	LogRecord getLogRecord ( ) {
		return new LogRecord(Level.WARNING, message());
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.SIRAPRISE.tests.officialtestset.TestResultDetails#log(java.io.PrintStream)
	 */
	@Override
	void log (PrintStream out) {
		out.println(message());
	}

}
