/**
 * 
 */
package be.SIRAPRISE.tests.officialtestset;

import java.io.PrintStream;
import java.util.logging.Level;
import java.util.logging.LogRecord;

import be.SIRAPRISE.util.MyMessageFormat;

/**
 * ExceptionTypeMismatch
 * 
 * @author erwin
 * 
 * 
 */
final class ExceptionTypeMismatch extends TestResultDetails {

	/**
	 * 
	 */
	private String errorClass;

	/**
	 * 
	 */
	private long expectedExceptionType;

	/**
	 * 
	 */
	private long obtainedExceptionType;

	/**
	 * Creates the ExceptionTypeMismatch
	 * 
	 * @param expectedExceptionType
	 * @param obtainedExceptionType
	 * @param errorClass
	 */
	ExceptionTypeMismatch (long expectedExceptionType, int obtainedExceptionType, String errorClass) {
		this(expectedExceptionType, obtainedExceptionType);
		this.errorClass = errorClass;
	}

	/**
	 * Creates the ExceptionTypeMismatch
	 * 
	 * @param expectedExceptionType
	 * @param obtainedExceptionType
	 */
	ExceptionTypeMismatch (long expectedExceptionType, long obtainedExceptionType) {
		this.expectedExceptionType = expectedExceptionType;
		this.obtainedExceptionType = obtainedExceptionType;
	}

	/**
	 * @return
	 */
	private String message ( ) {
		return errorClass == null ? MyMessageFormat.format("Exception type mismatch : expected {0} gotten {1}", new String[] { Long.toString(expectedExceptionType), Long.toString(obtainedExceptionType) }) : MyMessageFormat.format("Exception type mismatch : expected {0} gotten {1} ({2})", new String[] { Long.toString(expectedExceptionType), Long.toString(obtainedExceptionType), errorClass }); //$NON-NLS-1$ //$NON-NLS-2$
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.SIRAPRISE.tests.officialtestset.TestResultDetails#getLogRecord()
	 */
	@Override
	LogRecord getLogRecord ( ) {
		return new LogRecord(Level.WARNING, message());
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.SIRAPRISE.tests.officialtestset.TestResultDetails#log(java.io.PrintStream)
	 */
	@Override
	void log (PrintStream out) {
		out.println(message());
	}

}
