/**
 * 
 */
package be.SIRAPRISE.tests.officialtestset;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.fail;

import java.io.IOException;
import java.util.*;
import java.util.logging.*;

import org.junit.*;

import be.SIRAPRISE.client.*;
import be.SIRAPRISE.messages.CommunicationProtocolException;
import be.SIRAPRISE.util.*;

/**
 * @author Erwin
 * 
 */
public abstract class XMLSpeccedTest {

	// /**
	// *
	// */
	// private static boolean engineExplicitlyStarted = false;

	// /**
	// * @return
	// */
	// private static HashSet<String> getStillActiveThreadNames ( ) {
	// HashSet<String> stillActiveThreadNames = new HashSet<>();
	// final ThreadGroup threadGroup = Thread.currentThread().getThreadGroup();
	// Thread[] threadList = new Thread[2 * threadGroup.activeCount()];
	// threadGroup.enumerate(threadList);
	// for (Thread thread : threadList) {
	// if (thread != null) {
	// stillActiveThreadNames.add(thread.getName());
	// }
	// }
	// return stillActiveThreadNames;
	// }

	// /**
	// * @throws CommunicationProtocolException
	// * @throws DBException
	// */
	// @BeforeClass
	// public static void setUpBeforeClass ( ) throws CommunicationProtocolException, DBException {
	// // check if engine needs to be started ; try to connect to one that has been started
	// try {
	//			new OneShotDBConnection(new SiraPriseServer(DBConnectionProperties.HOSTDEFAULT, Integer.parseInt(DBConnectionProperties.PORTDEFAULT), Integer.parseInt(DBConnectionProperties.MONITORPORTDEFAULT)), new HashSet<String>(), "", null).close(); //$NON-NLS-1$
	// } catch (IOException e) {
	// engineExplicitlyStarted = true;
	// StartServerEngine.main(new String[] {});
	// boolean connectionEstablished = false;
	// // don't leave this method until we're really sure we can connect ... The engine needs some time to start !!!!
	// while (!connectionEstablished) {
	// try {
	//					new OneShotDBConnection(new SiraPriseServer(DBConnectionProperties.HOSTDEFAULT, Integer.parseInt(DBConnectionProperties.PORTDEFAULT), Integer.parseInt(DBConnectionProperties.MONITORPORTDEFAULT)), new HashSet<String>(), "", null).close(); //$NON-NLS-1$
	// connectionEstablished = true;
	// } catch (IOException e1) {
	// try {
	// Thread.sleep(500);
	// } catch (InterruptedException e2) {
	//
	// }
	// }
	// }
	// }
	// }

	// /**
	// *
	// */
	// @AfterClass
	// public static void tearDownAfterClass ( ) {
	// if (engineExplicitlyStarted) {
	// StopServerEngine.main(new String[] { DBConnectionProperties.HOST + '(' + DBConnectionProperties.HOSTDEFAULT + ')', DBConnectionProperties.MONITORPORT + '(' + DBConnectionProperties.MONITORPORTDEFAULT + ')' });
	// // Leave the engine the time to clean up !!!
	// while (getStillActiveThreadNames().contains(ServerEngine.getMainSocketListenerThreadName())) {
	// try {
	// Thread.sleep(500);
	// } catch (InterruptedException e) {
	//
	// }
	// }
	// }
	// }

	/**
	 * 
	 */
	private boolean closeInTearDown = true;

	/**
	 * 
	 */
	private OneShotDBConnection dbc;

	/**
	 * 
	 */
	@Before
	public void setUp ( ) {
		boolean retry = false;
		do {
			retry = false;
			try {
				// get the DB connection
				dbc = new OneShotDBConnection(new SiraPriseServer(DBConnectionProperties.HOSTDEFAULT, Integer.parseInt(DBConnectionProperties.PORTDEFAULT), Integer.parseInt(DBConnectionProperties.MONITORPORTDEFAULT)), "", null); //$NON-NLS-1$
			} catch (DBException e1) {
				if (e1.getErrorCode() == 454) { // max connections exceeded
					try {
						Thread.sleep(100);
					} catch (InterruptedException e) {

					}
					retry = true;
				} else {
					fail(e1.getClass().getName() + ':' + e1.getMessage());
				}
			} catch (IOException e) {
				fail(e.getClass().getName() + ':' + e.getMessage());
			} catch (CommunicationProtocolException e) {
				fail(e.getClass().getName() + ':' + e.getMessage());
			}
		} while (retry);

	}

	/**
	 * 
	 */
	@After
	public void tearDown ( ) {
		if (closeInTearDown) {
			dbc.close();
		}
	}

	/**
	 * 
	 */
	@Test
	public void test ( ) {
		for (String testCaseName : this.getClass().getAnnotation(TestCase.class).name()) {
			System.out.println();
			System.out.println(testCaseName);
			try {
				Collection<MyReadOnlyEntry<String, TestResultDetails>> results = new TestScenario(dbc, testCaseName, false).runTest();
				for (MyReadOnlyEntry<String, TestResultDetails> unexpectedeResult : results) {
					Logger.getLogger(this.getClass().getName()).log(Level.WARNING, unexpectedeResult.getKey());
					Logger.getLogger(this.getClass().getName()).log(unexpectedeResult.getValue().getLogRecord());
				}

				if (results.size() > 0) {
					System.out.println();
					for (MyReadOnlyEntry<String, TestResultDetails> myReadOnlyEntry : results) {
						System.out.println(myReadOnlyEntry.getKey());
						myReadOnlyEntry.getValue().log(System.out);
					}
				}
				assertEquals(0, results.size());
			} catch (ConnectionClosedException e) {
				closeInTearDown = false;
				final String failMessage = testCaseName + '-' + e.getClass().getName() + '-' + e.getMessage();
				Logger.getLogger(this.getClass().getName()).log(Level.SEVERE, failMessage, e);
				fail(failMessage);
			}
		}
	}
}
