#! /bin/sh
### BEGIN INIT INFO
# Provides:          siraprise
# Required-Start:    $local_fs $remote_fs $network
# Required-Stop:     $local_fs $remote_fs $network
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: SIRA_PRISE server
# Description:       SIRA_PRISE server
### END INIT INFO

# Author: Erwin Smout <sira_prise@edpnet.be>
#
# Please remove the "Author" lines above and replace them
# with your own name if you copy and modify this script.

# You are strongly encouraged to customize this script according to your own needs and/or service script philosophies, since if you are using linux it is highly likely that you know and understand proper shell script practices better than I do.

# Do NOT "set -e"

# PATH should only include /usr/* if it runs after the mountnfs.sh script
PATH=/sbin:/usr/sbin:/bin:/usr/bin
DESC="SIRA_PRISE server"
NAME=SIRA_PRISE
# DAEMON=/usr/sbin/$NAME
# DAEMON_ARGS="--options args"
# PIDFILE=/var/run/$NAME.pid
SCRIPTNAME=/etc/init.d/$NAME

# Exit if the package is not installed
# [ -x "$DAEMON" ] || exit 0

# Read configuration variable file if it is present
# [ -r /etc/default/$NAME ] && . /etc/default/$NAME

# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
# and status_of_proc is working.
. /lib/lsb/init-functions

case "$1" in
  start)
	[ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
	su - siraprise -c "$SIRA_PRISE_HOME/server/sp.startsrv.sh &"
	;;
  stop)
	[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
	su - siraprise -c "$SIRA_PRISE_HOME/server/sp.stopsrv.sh"
	;;
#  status)
#	status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
#	;;
  #reload|force-reload)
	#
	# If do_reload() is not implemented then leave this commented out
	# and leave 'force-reload' as an alias for 'restart'.
	#
	#log_daemon_msg "Reloading $DESC" "$NAME"
	#do_reload
	#log_end_msg $?
	#;;
  restart)
	#
	# If the "reload" option is implemented then remove the
	# 'force-reload' alias
	#
	log_daemon_msg "Restarting $DESC" "$NAME"
	su - siraprise -c "$SIRA_PRISE_HOME/server/sp.stopsrv.sh"
	sleep 2
	su - siraprise -c "$SIRA_PRISE_HOME/server/sp.startsrv.sh &"
	;;
  *)
	#echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
	echo "Usage: $SCRIPTNAME {start|stop|restart}" >&2
	exit 3
	;;
esac

:
